﻿'Prologue



Public Class frmLineChart
    Dim mgrfChart As Graphics

    Private Sub frmLineChart_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        mgrfChart = Me.CreateGraphics

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        End

    End Sub

    Private Sub btnPlot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlot.Click
        Dim srdStockPrices As System.IO.StreamReader
        Dim strQuarter As String
        Dim strYear As String
        Dim decPrice As Decimal
        Dim decChange As Decimal
        Dim strRecord() As String
        Dim decOldPrice As Decimal = 30
        Dim strLine As String
        Dim sngSpacing As Single = 40
        Dim penChartLines As New Pen(Color.Black, 4)
        Dim penPlotLines As New Pen(Color.Black, 3)
        Dim sngX As Single
        Dim sngXOld As Single = 25
        Dim sngY As Single
        Dim sngYOld As Single = 400
        Dim sngChange As Single

        'Set filename
        srdStockPrices = New System.IO.StreamReader("GREEDPrices.dat")

        'Heading
        mgrfChart.DrawString("GREED Stock Price Changes", New System.Drawing.Font("Arial", 24) _
                           , Brushes.Black, 75, 25)

        'Chart lines
        'Draws boundaries for chart and labels them
        mgrfChart.DrawLine(penChartLines, 25, 75, 25, 425)
        mgrfChart.DrawLine(penChartLines, 23, 425, 550, 425)
        mgrfChart.DrawString("Quarter", New System.Drawing.Font("Arial", 10) _
                             , Brushes.Black, 500, 400)
        mgrfChart.DrawString("Price", New System.Drawing.Font("Arial", 10) _
                             , Brushes.Black, 35, 80)

        'Draws legend at the bottom
        mgrfChart.DrawString("Closing Price at the end of each quarter", _
                             New System.Drawing.Font("Arial", 10), _
                             Brushes.Black, 50, 525)

        Do Until srdStockPrices.Peek = -1
            'Input
            strLine = srdStockPrices.ReadLine
            strRecord = strLine.Split(",")
            strQuarter = strRecord(0)
            strYear = strRecord(1)
            decPrice = Convert.ToDecimal(strRecord(2))
            decChange = Convert.ToDecimal(strRecord(3))

            'Processing
            'Location change is calculated from old price and new price
            sngChange = ((decChange / decPrice) * 100) * 10
            sngX = sngXOld + sngSpacing
            sngY = sngYOld - sngChange

            'Change color Green for price increase, Red for price decrease
            If decChange >= 0 Then
                penPlotLines = New Pen(Color.Green, 3)
            Else
                penPlotLines = New Pen(Color.Red, 3)
            End If
            mgrfChart.DrawLine(penPlotLines, sngXOld, sngYOld, sngX, sngY)

            'Output
            'Draws labels
            mgrfChart.DrawString(decPrice.ToString("c"), New System.Drawing.Font("Arial", 10) _
                               , Brushes.Black, sngX, sngY)

            mgrfChart.DrawString("  " & strQuarter, New System.Drawing.Font("Arial", 10) _
                               , Brushes.Black, sngX, 430)
            mgrfChart.DrawString(strYear, New System.Drawing.Font("Arial", 10) _
                               , Brushes.Black, sngX, 450)

            'Updates X and Y location for starting point of next line
            sngXOld = sngX
            sngYOld = sngY

        Loop

        'Close File
        srdStockPrices.Close()


    End Sub

End Class
