﻿'Simple Paint Program
'Demo of painting tools

Public Class frmPaintTutorial
    Dim mgrfPainter As Graphics                   'Creates Graphic
    Dim xDown As Integer                          'Starting X position
    Dim yDown As Integer                          'Starting Y position
    Dim xUp As Integer                            'Ending X position
    Dim yUp As Integer                            'Ending Y position
    Dim mblnCanPaint As Boolean = False           'Used to paint when set to True
    Dim mblnDrawShape As Boolean = False          'Used to draw shapes when set to True
    Dim mblnDrawRectangle As Boolean = False      'Used to draw rectangles when set to True
    Dim mblnDrawSquare As Boolean = False         'Used to draw squares when set to True
    Dim mblnDrawOval As Boolean = False           'Used to draw ovals when set to True
    Dim mblnDrawCircle As Boolean = False         'Used to draw circles when set to True
    Dim mblnDrawLine As Boolean = False           'Used to draw lines when set to True
    Dim mblnWriteText As Boolean = False          'Used to draw text when set to True
    Dim mrecPainter As System.Drawing.Rectangle   'Drawing surface
    Dim mclrSelected As Color = Color.Black       'Sets painting color
    Dim mstrText As String                        'String for adding text
    Dim mstrFont As String = "Arial"              'Sets intial font
    Dim mintBrushSize As Integer = 12             'Sets initial Brush size

    Private Sub frmPaintTutorial_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Instantiates Graphic and sets its size
        mgrfPainter = Me.CreateGraphics
        mrecPainter.Height = 500
        mrecPainter.Width = 500

    End Sub

    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        'Creates a new paint area and displays buttons
        mgrfPainter.FillRectangle(Brushes.White, mrecPainter)
        tlsShapes.Visible = True
        btnColor.Visible = True
        btnFont.Visible = True
        nudBrushSize.Visible = True

    End Sub

    Private Sub frmPaintTutorial_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        'Determines the mouse location
        'Sets the xy starting point for drawing graphics
        'Starting point cannot be outside the drawing area
        'Sets mblnCanPaint to true so painting can be done
        xDown = e.X
        yDown = e.Y

        If xDown > 500 Then xDown = 500
        If yDown > 500 Then yDown = 500

        mblnCanPaint = True

    End Sub

    Private Sub frmPaintTutorial_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        'Handles mouse moves
        'Sets the Brush size
        'Paints on the screen only when mblnCanPaint is true and others are false
        'Checks mouse location and keeps mouse withing paint area
        'Adjusts for mouse location and Brush size
        Dim intBrushSize As Integer

        intBrushSize = nudBrushSize.Value

        If mblnCanPaint And Not mblnDrawShape And Not mblnDrawLine And Not mblnWriteText Then
            xDown = e.X
            yDown = e.Y
            If xDown > 500 Then xDown = 500 - intBrushSize
            If yDown > 500 Then yDown = 500 - intBrushSize

            'Regular brush
            mgrfPainter.FillEllipse(New SolidBrush(mclrSelected), xDown, yDown, intBrushSize, intBrushSize)

            'Calligraphy brush
            'mgrfPainter.FillEllipse(New SolidBrush(mclrSelected), xDown, yDown, intBrushSize, intBrushSize * 5)
        End If

    End Sub

    Private Sub frmPaintTutorial_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        Dim xStart As Integer
        Dim yStart As Integer
        Dim xEnd As Integer
        Dim yEnd As Integer
        Dim xDistance As Integer
        Dim yDistance As Integer
        Dim bshFill As SolidBrush
        Dim penLine As New Pen(Color.Black, 2)

        'Sets Brush to selected color
        bshFill = New System.Drawing.SolidBrush(mclrSelected)

        'Turns off painting when the mouse is up
        mblnCanPaint = False

        'Gets the XY position when the mouse button is released
        xUp = e.X
        yUp = e.Y

        'Resets mouse position if it's outside drawing area
        If xUp > 500 Then xUp = 500
        If yUp > 500 Then yUp = 500

        'Draws selected shape when True
        If mblnDrawShape Then

            'Sets Brush size
            mintBrushSize = nudBrushSize.Value

            'Compares X start and end positions
            'Sets low value to XStart and high value to XEnd
            'Does the same for Y start and end positions
            'Enables user to create shapes from any direction
            If xUp < xDown Then
                xStart = xUp
                xEnd = xDown
            Else
                xStart = xDown
                xEnd = xUp
            End If
            If yUp < yDown Then
                yStart = yUp
                yEnd = yDown
            Else
                yStart = yDown
                yEnd = yUp
            End If

            'Calculates length of X and Y
            xDistance = xEnd - xStart
            yDistance = yEnd - yStart

            If mblnDrawRectangle Then
                'Draws Rectangle
                mgrfPainter.FillRectangle(bshFill, xStart, yStart, xDistance, yDistance)
            End If

            If mblnDrawOval Then
                'Draws Oval
                mgrfPainter.FillEllipse(bshFill, xStart, yStart, xDistance, yDistance)
            End If

            If mblnDrawCircle Then
                'Draws Circle
                mgrfPainter.FillEllipse(bshFill, xStart, yStart, xDistance, xDistance)

            End If
            If mblnDrawSquare Then
                'Draws Square
                mgrfPainter.FillRectangle(bshFill, xStart, yStart, xDistance, xDistance)

            End If
        End If

        If mblnDrawLine Then
            'Draws straight line
            penLine.Color = mclrSelected
            penLine.Width = mintBrushSize
            mgrfPainter.DrawLine(penLine, xDown, yDown, xUp, yUp)
        End If

        If mblnWriteText Then
            'Draws text
            mstrText = txtText.Text
            mgrfPainter.DrawString(mstrText, New System.Drawing.Font(mstrFont, mintBrushSize), bshFill, xUp, yUp)

        End If
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        'Ends the program
        End

    End Sub

    Private Sub btnColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnColor.Click
        'Displays ColorDialog
        clrDialog.ShowDialog()
        mclrSelected = clrDialog.Color

    End Sub

    Private Sub btnFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFont.Click
        'Display font dialog to set font and size
        fntDialog.ShowDialog()

        mstrFont = fntDialog.Font.Name
        mintBrushSize = fntDialog.Font.Size

    End Sub

    Private Sub ChangeButtons()
        'Changes BackColor for ToolStrip buttons
        'Turns off all the painting settings
        tlsShapesRectangle.BackColor = Color.LightBlue
        tlsShapesOval.BackColor = Color.LightBlue
        tlsShapesCircle.BackColor = Color.LightBlue
        tlsShapesSquare.BackColor = Color.LightBlue
        tlsShapesBrush.BackColor = Color.LightBlue
        tlsShapesLine.BackColor = Color.LightBlue
        tlsShapesText.BackColor = Color.LightBlue
        lblTextDirections.Visible = False

        mblnDrawShape = False

        mblnDrawRectangle = False
        mblnDrawOval = False
        mblnDrawCircle = False
        mblnDrawSquare = False
        mblnDrawLine = False
        mblnWriteText = False

    End Sub

    Private Sub tlsShapesRectangle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tlsShapesRectangle.Click
        'Settings for drawing rectangles
        ChangeButtons()

        If mblnDrawRectangle Then
            tlsShapesRectangle.BackColor = Color.LightBlue
            mblnDrawShape = False
            mblnDrawRectangle = False
        Else
            tlsShapesRectangle.BackColor = Color.DarkGray
            mblnDrawShape = True
            mblnDrawRectangle = True
        End If

    End Sub

    Private Sub tlsShapesOval_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tlsShapesOval.Click
        'Settings for drawing ovals
        ChangeButtons()

        If mblnDrawOval Then
            tlsShapesOval.BackColor = Color.LightBlue
            mblnDrawShape = False
            mblnDrawOval = False
        Else
            tlsShapesOval.BackColor = Color.DarkGray
            mblnDrawShape = True
            mblnDrawOval = True
        End If

    End Sub

    Private Sub tlsShapesCircle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tlsShapesCircle.Click
        'Settings for drawing a circle
        ChangeButtons()

        If mblnDrawCircle Then
            tlsShapesCircle.BackColor = Color.LightBlue
            mblnDrawShape = False
            mblnDrawCircle = False
        Else
            tlsShapesCircle.BackColor = Color.DarkGray
            mblnDrawShape = True
            mblnDrawCircle = True
        End If

    End Sub

    Private Sub tlsShapesSquare_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tlsShapesSquare.Click
        'Setting for drawing a square
        ChangeButtons()

        If mblnDrawSquare Then
            tlsShapesSquare.BackColor = Color.LightBlue
            mblnDrawShape = False
            mblnDrawSquare = False
        Else
            tlsShapesSquare.BackColor = Color.DarkGray
            mblnDrawShape = True
            mblnDrawSquare = True
        End If

    End Sub

    Private Sub tlsShapesBrush_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tlsShapesBrush.Click
        'Settings for paintbrush
        ChangeButtons()

        If mblnDrawShape Then
            tlsShapesBrush.BackColor = Color.LightBlue
            mblnCanPaint = False
        Else
            tlsShapesBrush.BackColor = Color.DarkGray
        End If

    End Sub

    Private Sub tlsShapesLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tlsShapesLine.Click
        'Settings for adding lines
        ChangeButtons()

        If mblnDrawLine Then
            tlsShapesLine.BackColor = Color.LightBlue
            mblnDrawLine = False
            mblnDrawShape = False
        Else
            tlsShapesLine.BackColor = Color.DarkGray
            mblnDrawLine = True
            mblnCanPaint = False

        End If

    End Sub

    Private Sub tlsShapesText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tlsShapesText.Click
        'Settings for adding text
        ChangeButtons()

        If mblnWriteText Then
            tlsShapesText.BackColor = Color.LightBlue
            mblnWriteText = False
            mblnDrawShape = False
        Else
            tlsShapesText.BackColor = Color.DarkGray
            mblnWriteText = True
            mblnCanPaint = False

        End If

        'Displays prompt for TextBox
        lblTextDirections.Visible = True

    End Sub

    Private Sub tlsShapes_ItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles tlsShapes.ItemClicked

    End Sub
End Class
