﻿'Prologue


Public Class frmPieChart
    Dim mgrfChart As Graphics

    Private Sub frmPieChart_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        mgrfChart = Me.CreateGraphics

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        End

    End Sub

    Private Sub btnPlot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlot.Click
        Dim srdSales As System.IO.StreamReader
        Dim strCategory() As String
        Dim decSales() As Decimal
        Dim strRecord() As String
        Dim strLine As String
        Dim decTotalSales As Decimal
        Dim i As Integer
        Dim sngOldArc As Single
        Dim sngArc As Single
        Dim shoYChange As Short = 20

        'Set filename
        srdSales = New System.IO.StreamReader("PlanetPlants.dat")

        'Load data from file into an array
        Do Until srdSales.Peek = -1
            'Resize arrays
            ReDim Preserve strCategory(i)
            ReDim Preserve decSales(i)

            'Input
            strLine = srdSales.ReadLine
            strRecord = strLine.Split(",")
            strCategory(i) = strRecord(0)
            decSales(i) = Convert.ToDecimal(strRecord(1))

            'Find total sales
            decTotalSales += decSales(i)

            i += 1

        Loop

        'Close File
        srdSales.Close()


        For i = 0 To strCategory.GetUpperBound(0)

            'Calculate size of pie slice and draw chart
            'Percentage of total sales is calculated as percentage of total pie
            sngArc = (decSales(i) / decTotalSales) * 360

            'Select color and draw slice based on item
            'First line draws slice
            'Second line draws color in legend
            'Third line is category
            'Fourth line is sales
            Select Case i
                Case Is = 0
                    mgrfChart.FillPie(Brushes.Red, 75, 75, 450, 450, sngOldArc, sngArc)
                    mgrfChart.FillRectangle(Brushes.Red, 15, shoYChange, 10, 15)
                    mgrfChart.DrawString(strCategory(i), New System.Drawing.Font("Arial", 12), Brushes.Black, 25, shoYChange)
                    mgrfChart.DrawString(decSales(i).ToString("c"), New System.Drawing.Font("Arial", 12), Brushes.Black, 90, shoYChange)
                Case Is = 1
                    mgrfChart.FillPie(Brushes.Green, 75, 75, 450, 450, sngOldArc, sngArc)
                    mgrfChart.FillRectangle(Brushes.Green, 15, shoYChange, 10, 15)
                    mgrfChart.DrawString(strCategory(i), New System.Drawing.Font("Arial", 12), Brushes.Black, 25, shoYChange)
                    mgrfChart.DrawString(decSales(i).ToString("c"), New System.Drawing.Font("Arial", 12), Brushes.Black, 90, shoYChange)
                Case Is = 2
                    mgrfChart.FillPie(Brushes.Blue, 75, 75, 450, 450, sngOldArc, sngArc)
                    mgrfChart.FillRectangle(Brushes.Blue, 15, shoYChange, 10, 15)
                    mgrfChart.DrawString(strCategory(i), New System.Drawing.Font("Arial", 12), Brushes.Black, 25, shoYChange)
                    mgrfChart.DrawString(decSales(i).ToString("c"), New System.Drawing.Font("Arial", 12), Brushes.Black, 90, shoYChange)
                Case Is = 3
                    mgrfChart.FillPie(Brushes.Yellow, 75, 75, 450, 450, sngOldArc, sngArc)
                    mgrfChart.FillRectangle(Brushes.Yellow, 15, shoYChange, 10, 15)
                    mgrfChart.DrawString(strCategory(i), New System.Drawing.Font("Arial", 12), Brushes.Black, 25, shoYChange)
                    mgrfChart.DrawString(decSales(i).ToString("c"), New System.Drawing.Font("Arial", 12), Brushes.Black, 90, shoYChange)
                Case Is = 4
                    mgrfChart.FillPie(Brushes.Purple, 75, 75, 450, 450, sngOldArc, sngArc)
                    mgrfChart.FillRectangle(Brushes.Purple, 15, shoYChange, 10, 15)
                    mgrfChart.DrawString(strCategory(i), New System.Drawing.Font("Arial", 12), Brushes.Black, 25, shoYChange)
                    mgrfChart.DrawString(decSales(i).ToString("c"), New System.Drawing.Font("Arial", 12), Brushes.Black, 90, shoYChange)
            End Select

            'Stop point of arc becomes start point for next arc
            sngOldArc += sngArc

            'Changes Y location on legend
            shoYChange += 20
        Next i

        'Draw labels
        mgrfChart.DrawString("Sales Breakdown by Category", New System.Drawing.Font("Arial", 16) _
           , Brushes.Black, 150, 530)

    End Sub

End Class
